/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/

/** \file spi2_hw.h

	Second Serial Peripheral Interface (HW) routines



Put the following into your config.h

// - - - - - - - - - - - - - - - - - - - - 
// spi2_hw defines
// - - - - - - - - - - - - - - - - - - - - 

//#define SPI2_HW_MASTER_MODE
// or
#define SPI2_HW_SLAVE_MODE

// In slave mode, we can use ss:
//#define SPI2_HW_USE_SS

// In master mode, we need to define clock
//#define SPI2_HW_MASTER_CLOCK_TMR2_DIV_2
//#define SPI2_HW_MASTER_CLOCK_FOSC_DIV_64
//#define SPI2_HW_MASTER_CLOCK_FOSC_DIV_16
//#define SPI2_HW_MASTER_CLOCK_FOSC_DIV_4

#define SPI2_HW_TRANSMIT_ON_ACT_TO_IDLE	
// or
//#define SPI2_HW_TRANSMIT_ON_IDLE_TO_ACT

//#define SPI2_HW_CLK_IDLE_IS_HIGH
// or
#define SPI2_HW_CLK_IDLE_IS_LOW

// - - - - - - - - - - - - - - - - - - - - 
*/


#ifndef __spi2_hw_h
#define __spi2_hw_h


#include "pic_utils.h"
#include "config.h"

void spi2_hw_setup_io();
void spi2_hw_init();
void spi2_hw_master_transmit(uns8 data);
uns8 spi2_hw_master_receive();
void spi2_hw_reset();

#endif