//-----------------------------------------------------
// Pic Pack library
// 
// WRL-3000 (CC3000 demo)
//

//
// Ian Harris 2013
// www.embeddedadventures.com
//
//-----------------------------------------------------



// Pic Pack includes
#include "config.h"
#include "pic_utils.h"
#include "pic_serial.h"

// System includes
#include "string.h"
#include "stdlib.h"
#include "config.h"
#include "pic_term.h"
#include "debug.h"

#include "cc3000\cc3000.h"
#include "cc3000\cc3000_hci.h"
#include "cc3000\cc3000_nvmem.h"
#include "cc3000\cc3000_general.h"
#include "cc3000\cc3000_wlan.h"
#include "cc3000\cc3000_network.h"
#include "cc3000\cc3000_socket.h"


bit process_smart_config = 0;
bit cc3000_started = 0;

// Interrupt routine - - - - - - - - - -

void interrupt() {
		
		if (test_bit(intcon, INT0IF) && test_bit(intcon, INT0IE)) {
			clear_bit(intcon, INT0IF);
			cc3000_handle_isr();
		}	
		serial_handle_tx_isr();
		serial_handle_rx_isr();
}

uns16 cc3000_print_str(uns8 sd, uns8 *s) {
		return cc3000_send(sd, s, strlen(s), 0); 	
}


void prowl(uns8 *application, uns8 *event, uns8 *msg) {

uns8 buffer[255];
ip_addr_t dest_ip;
int8 res;
int8 sd;
uns8 cl_buffer[10];
uns8 content_length;
	
	strcpy(buffer, "POST /publicapi/add?apikey=");
	//strcat(buffer, "2ed07bc83d14a6919341f82eef8ad7ebf89296b5");
	strcat(buffer, "88ed1f6073c840aad7b856a736dccbdbdf6eb0d8");
	strcat(buffer, "&application=");
	strcat(buffer, application);
	strcat(buffer, "&event=");
	strcat(buffer, event);
	strcat(buffer, "&description=");
	strcat(buffer, msg);
	strcat(buffer, "&priority=");
	strcat(buffer, "0 HTTP/1.0\r\n");
	
	content_length = 0;
	ltoa(content_length, cl_buffer, 10);
	
	serial_print_str("\n---Looking for DNS\n");
	res = cc3000_network_gethostbyname("prowlapp.com", &dest_ip);
	if (res < 0) {
		serial_print_str("Bad request");
	} else {
		serial_print_str("Lookup Result = ");
		serial_print_int(res);
		serial_print_nl();
		serial_print_int(dest_ip.ip[0]);
		serial_putc('.');
		serial_print_int(dest_ip.ip[1]);
		serial_putc('.');
		serial_print_int(dest_ip.ip[2]);
		serial_putc('.');
		serial_print_int(dest_ip.ip[3]);
		serial_print_nl();
		
		serial_print_str("--- socket\n");
		sd = cc3000_socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
		debug_var("\nsd=", sd);

		serial_print_str("--- connect...");
		status = cc3000_connect(sd, 80, dest_ip);
		serial_print_str("done, status=");
		serial_print_int(status);
		
		serial_print_str("\n--- sending data\n");
		uns16 sent = cc3000_print_str(sd, buffer); 
		debug_var("Bytes sent :", sent);
		sent = cc3000_print_str(sd, "Host: prowlapp.com\r\nUser-Agent: cc3000/pic_pack_lib\r\nContent-Type: application/text\r\n"); 
		debug_var("Bytes sent :", sent);
		sent = cc3000_print_str(sd, "Content-Length: "); 
		debug_var("Bytes sent :", sent);
		sent = cc3000_print_str(sd, cl_buffer);
		debug_var("Bytes sent :", sent);
		sent = cc3000_print_str(sd, "\r\n\r\n"); 
		debug_var("Bytes sent :", sent);
		//sent = cc3000_print_str(sd, buffer); 	//content
		//debug_var("Bytes sent :", sent);
		
		serial_print_str("--- receiving data...\n");
		uns8 buffer[220];
		uns16 received = cc3000_recv(sd, &buffer, 220, 0);
		debug_var("1received=", received);
		for (uns8 count = 0; count < received; count++) {
			serial_putc(buffer[count]);
		}			
		received = cc3000_recv(sd, &buffer, 220, 0);
		debug_var("2received=", received);
		for (uns8 count = 0; count < received; count++) {
			serial_putc(buffer[count]);
		}
		serial_print_str("--- closing socket\n");
		cc3000_socket_close(sd);
	}
	
}	

void cosm(uns16 x) {
	
ip_addr_t dest_ip;
int8 res;
int8 sd;
uns8 buffer[20];
uns8 cl_buffer[10];
uns8 content_length;
	
	ltoa(x, buffer, 10);
	content_length = strlen(buffer);
	ltoa(content_length, cl_buffer, 10);
	
	serial_print_str("---Looking for DNS\n");
	res = cc3000_network_gethostbyname("api.cosm.com", &dest_ip);
	if (res < 0) {
		serial_print_str("Bad request");
	} else {
		serial_print_str("Lookup Result = ");
		serial_print_int(res);
		serial_print_nl();
		serial_print_int(dest_ip.ip[0]);
		serial_putc('.');
		serial_print_int(dest_ip.ip[1]);
		serial_putc('.');
		serial_print_int(dest_ip.ip[2]);
		serial_putc('.');
		serial_print_int(dest_ip.ip[3]);
		serial_print_nl();
		
		serial_print_str("--- socket\n");
		sd = cc3000_socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
		debug_var("\nsd=", sd);

		serial_print_str("--- connect\n");
		status = cc3000_connect(sd, 80, dest_ip);
		debug_var("\nstatus=", status);
		
		serial_print_str("--- sending data\n");
		uns16 sent = cc3000_print_str(sd, "PUT /v2/feeds/129857/datastreams/temp.csv HTTP/1.0\r\n"); 
		debug_var("Bytes sent :", sent);
		sent = cc3000_print_str(sd, "Host: api.cosm.com\r\nUser-Agent: cc3000/cosm\r\nContent-Type: application/csv\r\n"); 
		debug_var("Bytes sent :", sent);
		sent = cc3000_print_str(sd, "X-ApiKey: TzcWBQRMSAng81I0mRlGaMzUs2t-7IGR1uVZeW_NKXo\r\nContent-Length: "); 
		debug_var("Bytes sent :", sent);
		sent = cc3000_print_str(sd, cl_buffer);
		debug_var("Bytes sent :", sent);
		sent = cc3000_print_str(sd, "\r\n\r\n"); 
		debug_var("Bytes sent :", sent);
		sent = cc3000_print_str(sd, buffer); 	//content
		debug_var("Bytes sent :", sent);
		
		serial_print_str("--- receiving data...\n");
		uns8 buffer[220];
		uns16 received = cc3000_recv(sd, &buffer, 220, 0);
		debug_var("received=", received);		
		received = cc3000_recv(sd, &buffer, 220, 0);
		debug_var("received=", received);
		serial_print_str("--- closing socket\n");		
		cc3000_socket_close(sd);
	}
}


void start_smart_config() {

	serial_print_str("--Set connection policy\n");
	cc3000_wlan_set_connection_policy(fast_connect_disabled, open_ap_auto_connect_disabled, use_profiles_disabled);
	serial_print_str("--Clear profiles\n");
	cc3000_wlan_del_profile(255);	// delete them all!
	serial_print_str("--Disconnect\n");
	cc3000_wlan_disconnect();	// disconnect
	serial_print_str("--Set prefix\n");
	cc3000_wlan_smart_config_set_prefix();
	serial_print_str("--Start smart config\n");
	cc3000_wlan_smart_config_start(0); 	// start! no ecryption
	serial_print_str("--Waiting for iPhone app\n");
	cc3000_hci_wait_for(HCI_EVENT_WLAN_ASYNC_SMART_CONFIG_DONE);
	cc3000_wlan_set_connection_policy(fast_connect_disabled, open_ap_auto_connect_disabled, use_profiles_enabled);
	serial_print_str("--Shutting down WLAN\n");
	
	cc3000_general_shutdown();
	
	delay_ms(250);
	delay_ms(250);
	delay_ms(250);
	delay_ms(250);
	serial_print_str("--Starting up\n");
	cc3000_general_startup(0);
	
	process_smart_config = 1;	// When we get connected, signal to iphone to stop the app (main loop)
	
}
	



uns8 sd;

void term_entry_callback(uns8 *term_buffer) {

uns8 data[5];
uns8 first_char;
uns8 status;
	
	first_char = term_buffer[0];

	if ((!cc3000_started) && (first_char != 's')) {
		serial_print_str("\nYou need to start the CC3000 first (s<enter>)\n");
		return;
	}	

	switch (first_char) {
		case '!':		// Smart config
			serial_print_str("\nSmart Config...");
			start_smart_config();
			serial_print_str("\nSmart Config is done!\n");
			break;
		case 's':	// Start CC3000
			serial_print_str("\nStart cc3000...\n");
			uns8 sp_maj, sp_min;
			uns8 free_buffers;
			uns16 buffer_length;
			
			cc3000_general_startup(0);

			status = cc3000_nvmem_read_sp_version(&sp_maj, &sp_min);
			debug_var("\nstatus=", status);
			serial_print_str(" done!\nService pack = ");
			serial_print_int(sp_maj);
			serial_putc('.');
			serial_print_int(sp_min);
			serial_print_nl();
			cc3000_started = 1;
			break;
		case 'z':	// Set scan params
			serial_print_str("\nSet scan params...");
			status = cc3000_wlan_set_scan_params(60, 0x1fff);
			serial_print_str("done!\n");
			break;
		case 'x':	// Get one entry from the scan
			ap_entry_t result;
			status = cc3000_wlan_get_scan_result(&result);
			serial_print_str("\nEntry count: ");
			serial_print_int(result.entry_count);
			serial_print_str("\nScan Status = ");
			switch (result.scan_status) {
				case 0: serial_print_str("Aged results"); break;
				case 1: serial_print_str("Results valid"); break;
				case 2: serial_print_str("No result"); break;
			}
			serial_print_str("\nThis entry valid: ");
			if (result.entry_valid) {
				serial_print_str("Yes");
			} else {
				serial_print_str("No");
			}
			serial_print_str("\nRSSI: ");
			serial_print_int(result.rssi);
			serial_print_str("\nSecurity: ");
			switch (result.security) {
				case 0: serial_print_str("Open"); break;
				case 1: serial_print_str("WEP"); break;
				case 2: serial_print_str("WPA"); break;
				case 3: serial_print_str("WPA2"); break;
			}
			serial_print_str("\nSSID: ");
			serial_print_str(result.ssid);
			serial_print_nl();
			break;
		case 'c':	// Connect to a network
			serial_print_str("Connect...\n");
			status = cc3000_wlan_connect("whiteBox", WLAN_SEC_WPA2, "apartment5g");
			debug_var("\nstatus=", status);
			break;

			
		case 'p':	// ping an address
			ip_addr_t ip_addr;
			
			ip_addr.ip[0] = 8;
			ip_addr.ip[1] = 8;
			ip_addr.ip[2] = 8;
			ip_addr.ip[3] = 8;
			serial_print_str("Sending ping...");
			status = cc3000_network_ping(ip_addr, 10, 10, 1000*10);
			debug_var("\nstatus=", status);
			serial_print_str("done!\n");
			break;	
		case 'r':	// get a ping report
			status = cc3000_network_ping_report();
			debug_var("\nstatus=", status);
			break;
		case 'm':	// kill those pesky keep alive messages
			status = cc3000_wlan_set_event_mask(HCI_EVENT_WLAN_KEEPALIVE);	
			debug_var("\nstatus=", status);
			break;
		case 'n':	// clear the connection policy
			status = cc3000_wlan_set_connection_policy(fast_connect_disabled, open_ap_auto_connect_disabled, use_profiles_disabled);
			debug_var("\nstatus=", status);
			break;
		case 'h':	// do a host name lookup
			ip_addr_t out_ip_addr;
			int8 res = cc3000_network_gethostbyname("www.embeddedadventures.com", &out_ip_addr);
			if (res < 0) {
				serial_print_str("Bad request\n");
			} else {
				serial_print_str("Lookup Result = ");
				serial_print_int_hex(res);
				serial_print_nl();
				serial_print_int(out_ip_addr.ip[0]);
				serial_putc('.');
				serial_print_int(out_ip_addr.ip[1]);
				serial_putc('.');
				serial_print_int(out_ip_addr.ip[2]);
				serial_putc('.');
				serial_print_int(out_ip_addr.ip[3]);
				serial_print_nl();
			}	
			break;

			break;
		case 'o': 	// Do a cosm test
			cosm(55);
			break;
		case '+':	// Do a prowl test
			prowl("My%20WRL-3000", "Guess%20what!", "I%20HAVE%20TAKEN%20OVER%20YOUR%20IPAD!!!");
			break;
		case '-':	// Show current connection status
			serial_print_str("\nConnected : ");
			if (cc3000_connected) {
				serial_print_str("Yes");
			} else {
				serial_print_str("No");
			}
			serial_print_str("\nSmart Completed : ");
			if (cc3000_smart_config_complete) {
				serial_print_str("Yes");
			} else {
				serial_print_str("No");
			}
			serial_print_str("\nHDCP complete : ");
			if (cc3000_dhcp_complete) {
				serial_print_str("Yes");
			} else {
				serial_print_str("No");
			}
			serial_print_str("\nProcess Smart: ");
			if (process_smart_config) {
				serial_print_str("Yes\n");
			} else {
				serial_print_str("No\n");
			}
			break;				
		default:
			serial_print_str("Unknown command.\n");
			break;
	}	// switch		

}	// term_entry_callback


// configure_system
//
// Get the pic ready for everything we want to do

void configure_system() {
	
	// turn off interrupts just in case
	kill_interrupts();
	
	// kill those pesky analogue inputs
	turn_analog_inputs_off();	
	
	// set serial to run at 115200bps 
	serial_setup(SPBRG_115200);
	
	cc3000_setup_io();
	cc3000_init();
	
	clear_bit(intcon, INT0IF);	// in case it was triggered already
	clear_bit(intcon2, INTEDG0);	// Need falling edge for mrf24j40 defaults
	//set_bit(intcon, INT0IE);	// turn on rb0/int0 interrupts

	
	// initialise termainal
	term_init();

	// tern peripheral interrupts on (ie, serial port)
	turn_peripheral_ints_on();
	
	// turn all interrupts on
	turn_global_ints_on();
}

void cc3000_callback_connect_status(uns8 connected, uns8 dhcp) {
	
	serial_print_str("Status change! ");
	if (connected) {
		serial_print_str(" <Connected> ");
	} else {
		serial_print_str(" <Disconnected> ");
	}
	if (dhcp) {
		serial_print_str(" <IP address good> ");
	} else {
		serial_print_str(" <No IP address yet> ");
	}
	serial_print_nl();
		
}

void main() {

	configure_system();
	
	delay_ms(100);	// mostly so screamer bootloader has time to switch windows
	
	serial_print_str("\n\nCC3000 Demo\n");
	serial_print_str( "\n<");
	
	// Print the time and date this file was compiled. Handy to know which
	// version you are running.
	
	serial_print_str(__TIME__);
	serial_putc(' ');
	serial_print_str(__DATE__);
	serial_print_str(">\n");


	for(;;) {

		term_process();
		if (process_smart_config  && cc3000_connected && cc3000_dhcp_complete) {
			process_smart_config = 0;
			debug_str("Doing MDNS prompt to tell iphone app all is well");
			cc3000_socket_mdns_advertise(1, "CC3000");
		}	
		
	}

	
}	// main

